﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using Infragistics.Win;
using System.Diagnostics;
using Infragistics.Win.UltraWinEditors;

namespace WG_DifferentInputMasksSameColumn
{

    public partial class Form1 : Form
    {
        EditorCache _editorCache;

        public Form1()
        {
            InitializeComponent();
        }

        private void Form1_Load(object sender, EventArgs e)
        {
            // generate example data source
            DataTable dt = new DataTable();
            dt.Columns.Add("ID", typeof(int)).AutoIncrement = true;
            dt.Columns.Add("Input Col", typeof(double));
            dt.Columns.Add("Input Mask", typeof(string));

            dt.Rows.Add(new object[] { null, 0, "nnn" });
            dt.Rows.Add(new object[] { null, 0, "nnn.nnn" });

            ultraGrid1.DataSource = dt;
        }

        private void UltraGrid1_InitializeRow(object sender, Infragistics.Win.UltraWinGrid.InitializeRowEventArgs e)
        {
            string inputMask = (string)e.Row.Cells["Input Mask"].Value;

            // Get an EmbeddableEditorBase that has a default owner with the specified
            // input mask. 
            EmbeddableEditorBase editor = this.EditorCache.GetEditor(inputMask);           

            // Assign the editor to the column. 
            e.Row.Cells["Input Col"].Editor = editor;
        }

        private EditorCache EditorCache
        {
            get
            {
                if (this._editorCache == null)
                {
                    this._editorCache = new EditorCache();
                }

                return this._editorCache;
            }
        }

    }
}
